// RasDial.h: interface for the TRasDial class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#pragma once

#undef DECL
#ifdef UTILS_DLL
#define DECL _declspec(dllexport)
#else
#define DECL _declspec(dllimport)
#endif

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ras.h>

// We need this for PC builds as a structure, but it's not defined for Windows versions below 0x500
#ifndef _WIN32_WCE
#if (WINVER < 0x500)
typedef struct _RAS_STATS
{
    DWORD   dwSize;
    DWORD   dwBytesXmited;
    DWORD   dwBytesRcved;
    DWORD   dwFramesXmited;
    DWORD   dwFramesRcved;
    DWORD   dwCrcErr;
    DWORD   dwTimeoutErr;
    DWORD   dwAlignmentErr;
    DWORD   dwHardwareOverrunErr;
    DWORD   dwFramingErr;
    DWORD   dwBufferOverrunErr;
    DWORD   dwCompressionRatioIn;
    DWORD   dwCompressionRatioOut;
    DWORD   dwBps;
    DWORD   dwConnectDuration;

} RAS_STATS, *PRAS_STATS;
#endif
#endif

class DECL TRasDial
{
public:
   TRasDial();
   virtual ~TRasDial();

   TCHAR* GetRasConnectionState();
   bool IsDisconnected();
   CString CreateAPNDialString(CString Apn);
   bool VerifyCustomDialString(CString Port, CString DialStr, CString InitStr, bool FullAT=true);
   bool CreateModemSettings(CString Port, CString DialStr, CString InitStr, bool FullAT=true);
   bool HasModemSettings(CString Port);
   DWORD Dial(CString Port, CString PhoneNumber, CString UserName, CString Password, 
              bool UseSlip, DWORD dwBaudRate, bool UseHardFlow, 
              RASIPADDR IpAddr, RASIPADDR DNS, DWORD dwRasOptions, DWORD dwTimeoutSeconds);
   bool ManageExisting(CString Port);
   void SetConnection(CString RasName, HRASCONN hRasConn);
   bool Hangup();
   DWORD CleanSettings(CString Port);
   void GetTotalStatistics(RAS_STATS& Stats);
   void GetCurrentStatistics(RAS_STATS& Stats);
   void ClearTotalStatistics();

public:
   bool m_bNeedReboot;

protected:
   bool TurnPortPower(bool On);   // Does not stick after app exit 
   bool ForcePortPower(bool On);  // Forces state change that will stick after app exit
   void UpdateStatistics();

protected:
   bool bIsDisconnected;
   HRASCONN m_hRasConn;
   int m_iPowerPort;
   CRITICAL_SECTION m_cs;
   RAS_STATS m_TotalStats;
   RAS_STATS m_LastStats;
};

void __cdecl ceprintf(LPCTSTR Fmt, ...);

extern CString ceprintf_filename;

